<template>
    <div>
        <v-dialog v-model="dialog" persistent class="resizes">
            <v-card style="zoom: 90%; flex-wrap: wrap; ">
                <v-card-title style="background-color:black;">
                    <h1 style="color:white;" class="catName">
                        {{ category.id ? 'EDITAR CATEGORIA' : 'CREAR CATEGORIA' }}
                    </h1>
                </v-card-title>
                <v-card-text>
                    <v-form v-model="isValidForm" lazy-validation ref="form" class="bordered">
                        <v-container>
                            <v-row>
                                <v-col md="3" sm="12">
                                    <span>Nombre por defecto de la categoria</span>
                                    <v-text-field
                                        v-model="auxCategoriy.name"
                                        :rules="categoryNameRules"
                                        required
                                        class="tf1"
                                        hint="nombre por defecto de la categoria"
                                        style="margin-top: 15px;"
                                    ></v-text-field>
                                </v-col>
                                <v-col md="3" sm="12">
                                    <span>Posición en vista principal</span>
                                    <v-text-field
                                        type="number"
                                        v-model="auxCategoriy.showsAtHomePriority"
                                        required
                                        class="tf1"
                                        style="margin-top: 15px; max-width: 200px;"
                                        hint="orden/posición en la que se mostrara en la sección principal de catálogo"
                                    ></v-text-field>
                                </v-col>
                                <v-col md="3" sm="12">
                                    <span>Posición en vista secundaria </span>
                                    <v-text-field
                                        type="number"
                                        v-model="auxCategoriy.order"
                                        required
                                        class="tf1"
                                        style="margin-top: 15px; max-width: 200px;"
                                        hint="orden en el que se mostrará en catálogo"
                                    ></v-text-field>
                                </v-col>

                                <v-col>
                                    <span>Icono de categoria</span>
                                    <v-row>
                                        <v-col md="6" sm="12">
                                            <v-card
                                                height="200px"
                                                width="200px"
                                                v-cloak
                                                @click="$refs.uploader.$refs.input.click()"
                                                @drop.prevent="fileDropped"
                                                :img="previewImg(fileCategory)"
                                                @dragover.prevent="dropzone(true)"
                                                @dragenter="dropzone(true)"
                                                @dragleave="dropzone(false)"
                                                style="display: inline-block; align-items: center;"
                                                class="ma-4 uploader"
                                            >
                                                <div style="position: absolute; margin-top: 25%;">
                                                    <v-icon
                                                        class="drop-icon"
                                                        style="display: contents;"
                                                        v-if="!dragover"
                                                        color="yellow darken-2"
                                                        size="50"
                                                        >mdi-cloud-upload-outline</v-icon
                                                    >
                                                    <v-icon
                                                        class="drop-icon"
                                                        style="display: contents;"
                                                        v-if="dragover"
                                                        color="yellow darken-2"
                                                        size="50"
                                                        >mdi-book-plus</v-icon
                                                    >
                                                    <v-chip md="2" small >
                                                        <span class="uploadLabel"><h6>Arrastra aquí</h6></span>
                                                    </v-chip>
                                                </div>
                                            </v-card>
                                        </v-col>
                                        <v-col lg="6" md="2" sm="12">
                                            <v-file-input
                                                accept="image/*"
                                                v-model="fileCategory"
                                                show-size
                                                ref="uploader"
                                                style="width: content-box"
                                            ></v-file-input>
                                        </v-col>
                                    </v-row>
                                </v-col>
                                <v-col cols="12">
                                    <v-row>
                                        <v-col>
                                            <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                                <HexCheckBox v-model="auxCategoriy.showsAtHome"></HexCheckBox>
                                                <span>¿En página principal?</span>
                                            </div>
                                        </v-col>
                                        <v-col>
                                            <div class="d-flex mx-5 mb-5" style="align-items:center;">
                                                <HexCheckBox v-model="auxCategoriy.active"></HexCheckBox>
                                                <span>Activar</span>
                                            </div>
                                        </v-col>
                                    </v-row>
                                </v-col>
                                <v-col cols="12" v-if="langsMenu.length > 0">
                                    <v-row class="table-title bordered" style="border-top:none;">
                                        <v-col v-for="lan in langsMenu" :key="lan.id">
                                            <span class="titles">{{ lan.name }}</span>
                                        </v-col>
                                    </v-row>
                                    <v-row class="table-body bordered" style="border-top:none;">
                                        <v-col v-for="lan in langsMenu" :key="lan.id">
                                            <span class="titles">
                                                <v-text-field
                                                    :label="lan.language"
                                                    :value="
                                                        langsCategoryFromComponent.get(lan.id)
                                                            ? langsCategoryFromComponent.get(lan.id).text
                                                            : undefined
                                                    "
                                                    @input="input => changeLangText(input, lan.id, lan.language)"
                                                    :rules="categoryRules"
                                                ></v-text-field
                                            ></span>
                                        </v-col>
                                    </v-row>
                                </v-col>
                                <v-col cols="12" style="color: black;" v-if="!!category.id">
                                    <h2 style="color:black;" class="catName">
                                        EDITAR SUBCATEGORIA
                                    </h2>
                                </v-col>
                                <v-col cols="12" v-if="!!category.id">
                                    <v-data-table
                                        :search="search"
                                        :headers="headers"
                                        :items="subcategoriesMenu"
                                        :show-select="false"
                                        :disable-pagination="true"
                                        :hide-default-footer="true"
                                        :sort-by="['order']"
                                        :sort-desc="[false]"
                                        class="bordered"
                                    >
                                        <template v-slot:top>
                                            <v-toolbar flat>
                                                <v-btn
                                                    class="mb-2"
                                                    style="font-weight:bold; font-size: small; border-radius: 20px;"
                                                    color="#fbc02d"
                                                    @click="initSubCategoryDialog"
                                                >
                                                    AÑADIR SUBCATEGORIA
                                                </v-btn>
                                                <v-spacer></v-spacer>
                                                <span
                                                    style="color: #72727f; font-weight:bold; padding-left: 5px; font-size: 1rem;"
                                                    >BUSCAR:</span
                                                >
                                                <v-text-field
                                                    v-model="search"
                                                    append-icon="mdi-magnify"
                                                    label="Nombre de SubCategoria "
                                                    single-line
                                                    hide-details
                                                    color="black"
                                                    style="
                            max-width: 600px;
                            padding-left: 10px;
                            padding-right: 20px;
                            text-justify: distribute-all-lines;
                            background-color: #FFFFFF;"
                                                    class="searchAuto"
                                                >
                                                </v-text-field>
                                            </v-toolbar>
                                        </template>
                                        <template v-slot:no-data>
                                            <v-alert :value="true" color="alert">
                                                No se encontro información.
                                            </v-alert>
                                        </template>
                                        <template v-slot:body="props">
                                            <draggable :list="props.items" tag="tbody" :move="checkMove">
                                                <tr v-for="(auxSubCategoriy, index) in props.items" :key="index">
                                                    <td>
                                                        <v-icon large class="rowHandle">
                                                            mdi-drag
                                                        </v-icon>
                                                    </td>
                                                    <td>
                                                        <span :v-model="(props.order = index)"></span>
                                                        {{ (auxSubCategoriy.order = index) }}
                                                    </td>
                                                    <td>
                                                        <v-text-field v-model="auxSubCategoriy.name"></v-text-field>
                                                    </td>
                                                    <td>
                                                        <input
                                                            type="checkbox"
                                                            color="#F9A825"
                                                            v-model="auxSubCategoriy.active"
                                                            @change="
                                                                itemselect(
                                                                    auxSubCategoriy.id,
                                                                    auxSubCategoriy.active,
                                                                    menuId,
                                                                    category.id
                                                                )
                                                            "
                                                        />
                                                    </td>
                                                    <td>
                                                        <v-btn
                                                            icon
                                                            @click="initSubCategoryDialog($event, auxSubCategoriy)"
                                                        >
                                                            <HexButton class="small-button btnHex">
                                                                <v-icon>mdi-pencil</v-icon>
                                                            </HexButton>
                                                        </v-btn>
                                                    </td>
                                                    <td>
                                                        <HexButton
                                                            class="small-button btnHex"
                                                            @click="deleteSubCategory(auxSubCategoriy)"
                                                        >
                                                            <v-icon>mdi-delete</v-icon>
                                                        </HexButton>
                                                    </td>
                                                </tr>
                                            </draggable>

                                            <v-btn
                                                style="width: 80%; margin-left: 18%;  z-index: 10; font-weight:bold; font-size: small; border-radius: 20px; background-color: #fbc02d;"
                                                @click="saveSubCategoryon(props.items)"
                                                v-if="props.items.length > 0"
                                                >guardar</v-btn
                                            >
                                        </template>
                                    </v-data-table>
                                </v-col>
                            </v-row>
                        </v-container>
                    </v-form>
                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="yellow darken-1" @click="closeWindow" class="btnwidth">CERRAR</v-btn>
                    <v-btn
                        color="yellow darken-1"
                        @click="saveCategory($event, auxCategoriy)"
                        class="btnwidth"
                        :disabled="!isValidForm"
                        >GUARDAR</v-btn
                    >
                </v-card-actions>
            </v-card>
            <Subcategory
                :subcategory="subcategory"
                :langsMenu="langsMenu"
                :dialog="showSubCategoryDialog"
                :menu-id="menuId"
                :category-id="category.id"
                @setShowSubCategory="setShowSubCategory"
                @saveSubCategory="saveSubCategory"
                @setMessage="setMessage"
            ></Subcategory>
        </v-dialog>
        <v-dialog v-model="message.show" rounded="" max-width="290">
            <v-alert
                style="text-align:center; margin:0;"
                justify="center"
                v-model="message.show"
                dismissible
                :type="message.type"
                >{{ message.message }}</v-alert
            >
        </v-dialog>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { Category as CategoryModel, DEFAULT_CATEGORY } from '@/model/menu/Category';
import { Subcategory as SubCategoryModel } from '@/model/menu/Subcategory';
import { LangMenu } from '@/model/menu/LangMenu';
import { LangText } from '@/model/LangText';
import { CATEGORIES, CATEGORY_LANGS_NAME, MENUS, SUBCATEGORIES } from '@/config/collectionsName';
import { db } from '@/config/firebase';
import { newTimestamp, serializeLangText, serializeSubCategory } from '@/config/serializables';
import LangList from '@/components/menu/LangList.vue';
import HexCheckBox from '@/components/commons/HexCheckBox.vue';
import HexButton from '@/components/commons/HexButton.vue';
import { isAlpha } from '@/StringUtils';
import DragAndDrop from '@/components/commons/DragAndDrop.vue';
import SubcategoryLanguages from '@/components/categories/SubcategoryLanguages.vue';
import draggable from 'vuedraggable';
import Subcategory from '@/components/menu/Subcategory.vue';
import { SubcategoryService } from '@/services/SubcategoryService';
import { namespace } from 'vuex-class';
import { Restaurant } from '@/model/Restaurant';
import { getFile } from '@/services/StorageService';

const restaurantStore = namespace('RestaurantModule');
@Component({
    components: {
        SubcategoryLanguages,
        DragAndDrop,
        LangList,
        HexCheckBox,
        draggable,
        Subcategory,
        HexButton
    }
})
export default class Category extends Vue {
    @restaurantStore.State
    restaurants!: Restaurant[];

    @Prop({ default: DEFAULT_CATEGORY })
    category!: CategoryModel;
    @Prop({ default: () => [] })
    langsMenu!: LangMenu[];
    @Prop({ default: false })
    dialog!: boolean;
    @Prop({ required: true })
    menuId!: string;
    @Prop({ default: () => [] })
    categories!: CategoryModel[];

    showSubCategoryDialog = false;
    search = '';

    subcategoryService = new SubcategoryService();

    subcategory = new SubCategoryModel('', false, '', '', 0);
    subcategoriesMenu: SubCategoryModel[] = [];

    auxCategoriy: CategoryModel = new CategoryModel('', false, '', false, 0, '', 0, newTimestamp());
    langsCategoryFromFire: LangText[] = [];
    langsCategoryFromComponent: Map<string, LangText> = new Map();

    fileCategory = new File([], '', undefined);
    filePreview = '';
    dragover = false;

    isValidForm = true;
    categoryNameRules = [(v: string) => (v && v.length > 1) || 'Nombre debe tener por lo menos 2 caracteres'];

    categoryRules = [
        (v: string) => (v && v.length > 1) || 'Este elemento es requerido,debe tener por lo menos 2 caracteres',
        (val: string) => isAlpha(val) || 'No debe tener caracteres especiales'
    ];

    headers = [
        {
            text: '',
            value: ''
        },
        {
            text: 'POSICIÓN',
            align: 'left',
            sortable: false,
            value: 'order'
        },
        {
            text: 'NOMBRE',
            align: 'center',
            sortable: false,
            value: 'name'
        },
        {
            text: 'ACTIVO',
            align: 'left',
            sortable: false,
            value: 'active'
        },
        {
            text: 'ver',
            align: 'left',
            sortable: false,
            value: 'id'
        },
        {
            text: 'Eliminar',
            align: 'left',
            sortable: false,
            value: 'id'
        }
    ];

    message: { message: string; type: 'success' | 'info' | 'warning' | 'error'; show: boolean } = {
        message: '',
        type: 'error',
        show: false
    };
    initSubCategoryDialog(event: Event, subcategory1?: SubCategoryModel) {
        if (!subcategory1) {
            subcategory1 = new SubCategoryModel('', false, '', '', 0);
        }
        this.subcategory = subcategory1;
        this.showSubCategoryDialog = true;
    }
    setShowSubCategory(show: boolean) {
        this.showSubCategoryDialog = show;
    }

    saveCategory(event: Event, category?: CategoryModel) {
        const isValid = (this.$refs.form as Vue & { validate: () => boolean }).validate();
        if (isValid) {
            const langCategoriesToFire = Array.from(this.langsCategoryFromComponent.values()).filter(
                langCat => langCat.text
            );
            console.log('arr', langCategoriesToFire);
            this.$emit('saveCategory', category, langCategoriesToFire, this.fileCategory);
            this.$emit('setShowCategoryModal', false);
        }
    }
    async saveSubCategoryon(subcategory1: SubCategoryModel[]) {
        console.log('subcatt', subcategory1);
        await this.subcategoryService.updateMenuSubCategoryBatch(this.menuId, this.category.id, subcategory1);
        this.$emit('setMessage', 'SUBCATEGORIA ACTUALIZADA', 'success');
        //await this.initStates();
        return;
    }

    async saveSubCategory(subcategory1: SubCategoryModel, langsSubCategory: LangText[], fileIconSubCategory: File) {
        console.log('entre al metodo', fileIconSubCategory, subcategory1.id);
        if (subcategory1.id) {
            await this.subcategoryService.updtaeMenuSubCategory(
                this.menuId,
                this.category.id,
                subcategory1,
                langsSubCategory,
                fileIconSubCategory
            );
            this.$emit('setMessage', 'DATOS SUBCATEGORIA ACTUALIZADOS', 'success');
            return;
        }
        await this.subcategoryService.createMenuSubCategory(
            this.menuId,
            this.category.id,
            subcategory1,
            langsSubCategory,
            fileIconSubCategory
        );
        this.$emit('setMessage', 'SUBCATEGORIA CREADA', 'success');
        return;
    }
    async deleteSubCategory(subcategory1: SubCategoryModel) {
        if (confirm('¿Realmente quieres eliminar esta subcategoria?')) {
            await this.subcategoryService.deleteMenuSubCategory(this.menuId, this.category.id, subcategory1);
            this.$emit('setMessage', 'SUBCATEGORIA ELIMINADA', 'info');
            return;
        }
    }

    async updateSubLanguages(newLanguage: LangText, menuId: string, categoryId: string, subcategoryId: string) {
        if (newLanguage.id) {
            await this.subcategoryService.updateSubLanguages(newLanguage, menuId, categoryId, subcategoryId);
            this.$emit('setMessage', 'DATOS GUARDADOS', 'success');
            return;
        }
    }

    async closeWindow() {
        this.auxCategoriy = Object.assign(this.auxCategoriy, this.category);
        this.$emit('setShowCategoryModal', false);
    }

    changeLangText(input: string, langId: string, lang: string) {
        this.langsCategoryFromComponent.set(langId, new LangText(langId, lang, input));
        // console.log('imprimido ok', this.langsCategoryFromComponent, input);
    }

    fileDropped(dragevent: DragEvent) {
        if (dragevent.dataTransfer) {
            this.dragover = false;
            this.fileCategory = dragevent.dataTransfer.files[0];
        }
    }
    previewImg(file: File) {
        if (file.size !== 0) {
            return URL.createObjectURL(file);
        } else {
            return this.filePreview;
        }
    }
    dropzone(ready: boolean) {
        this.dragover = ready;
    }
    async getFilesPreview(file: string) {
        return getFile(file || '');
    }

    @Watch('category')
    async onCategoryChange(newCategory: CategoryModel | null) {
        //  console.log('onCategoryChange', newCategory);
        //   console.log('from fire id', this.menuId);

        if (newCategory && newCategory.id) {
            await this.$bind(
                'langsCategoryFromFire',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(CATEGORIES)
                    .doc(this.category.id)
                    .collection(CATEGORY_LANGS_NAME),
                { serialize: serializeLangText }
            );
            await this.$bind(
                'subcategoriesMenu',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(CATEGORIES)
                    .doc(this.category.id)
                    .collection(SUBCATEGORIES),
                { serialize: serializeSubCategory }
            );
            // console.log('from fire', this.langsCategoryFromFire);
        }

        if (!newCategory?.id) {
            this.langsCategoryFromFire = [];
        }
        // console.log('reset', this.langsCategoryFromFire);
        this.langsCategoryFromComponent = new Map();
        this.fileCategory = new File([], newCategory?.icon || '');
        this.langsCategoryFromFire.forEach(langCategory =>
            this.langsCategoryFromComponent.set(langCategory.id, langCategory)
        );
        //console.log('from fire', this.auxCategoriy);
        this.auxCategoriy = Object.assign(this.auxCategoriy, this.category);
        //console.log('from fire', this.auxCategoriy);
        this.filePreview = await this.getFilesPreview(this.category.icon);
    }
    checkMove(evt: any) {
        // console.log('dragname', event);
        return evt.draggedContext.element.name;
    }
    async itemselect(subcategoryId: string, active: boolean, menuId: string, categoryId: string) {
        await this.subcategoryService.updateSubcategoryActive(
            {
                active: active
            },
            subcategoryId,
            categoryId,
            menuId
        );
        this.$emit('setMessage', 'EL STATUS DE LA SUBCATEGORIA HA CAMBIADO', 'success');
    }
    setMessage(message: string, type: 'success' | 'info' | 'warning' | 'error') {
        this.message = { message, type, show: true };
    }
}
</script>

<style type="text/css">
.uploader {
    border: 7px;
    border-style: dashed;
    border-color: #dde3f3 !important;
}
@media (max-width: 700px) {
    .catName {
        font-size: 20px;
    }
    .btnwidth {
        position: relative;
        width: 150px;
    }
    .tf1 {
        width: 800px;
        color: red;
    }
}
@media screen and (max-width: 1241px) {
}
</style>
